# Copyright (C) 2001-2003 All right reserved by Shinya Kondo ( CGI KON )

# 

	require "timelocal.pl";
	require "cgi-lib.pl";
	require "jcode.pl";

	&ReadParse;

	while(($key,$val) = each(%in)) {
		$$key = $val;
	}

	$LOG_DIR = "logs/";

	@WEEKS = ("()","()","()","()","()","()","()");
	@COLOR = ("#FF0000","#000000","#000000","#000000","#000000","#000000","#0000FF");

# μ

sub Get_Wday
{
	my($year,$mon) = @_;

	my($time) = timelocal(0,0,0,1,$mon - 1,$year);
	my($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime($time);

	return $wday;
}

# μ

sub Get_Days
{
	my($year,$mon) = @_;

	my(@day_list) = (31,28,31,30,31,30,31,31,30,31,30,31);

	return $day_list[$mon - 1] if($mon != 2);

	if($year % 400 == 0) {
		return 29;
	} elsif($year % 100 == 0) {
		return 28;
	} elsif($year % 4 == 0) {
		return 29;
	} else {
		return 28;
	}
}

# ̳֤λ

sub Calc_Time
{
	my($time1,$time2) = @_;

	return 0 if($time1 eq "");
	return 0 if($time2 eq "");

	my($hour1,$min1) = split(":",$time1);
	my($hour2,$min2) = split(":",$time2);

	my($time) = ($hour2 * 60) + $min2 - ($hour1 * 60) - $min1;
	return 0 if($time <= 0);

	return $time;
}

# ΥեޥåѴ

sub Form_Time
{
	my($time) = @_;

	return "" if($time == 0);

	my($min) = $time % 60;
	my($hour) = ($time - $min) / 60;

	return sprintf("%02d:%02d",$hour,$min);
}

# СϿ

sub Put_Member
{
	my($filename,$id,$name) = @_;

	if(open(OFILE,">>".$LOG_DIR.$filename)) {
		$name =~ s/&/&amp;/g;
		$name =~ s/"/&quot;/g;
		$name =~ s/</&lt;/g;
		$name =~ s/>/&gt;/g;

		print OFILE "$id\t$name\n";
		close(OFILE);
	} else {
		$error = "ѼԤϿ˼Ԥޤ";
		require "error.inc";
		exit;
	}
}

# С̾μ

sub Get_Member
{
	my($filename,$id) = @_;

	my($record,$key,$val,$result);

	if(open(IFILE,$LOG_DIR.$filename)) {
		while($record = <IFILE>) {
			chomp($record);
			($key,$val) = split("\t",$record);
			$result = $val if($key eq $id);
		}
		close(IFILE);
	}

	return $result;
}

# Сμ

sub List_Member
{
	my($filename,$result) = @_;

	my($record,$key,$val);

	if(open(IFILE,$LOG_DIR.$filename)) {
		while($record = <IFILE>) {
			chomp($record);
			($key,$val) = split("\t",$record);
			$$result{$key} = $val;
		}
		close(IFILE);
		return 1;
	}

	return 0;
}

# Ͽ

sub Put_Time
{
	my($filename,$type) = @_;

	if(open(OFILE,">>".$LOG_DIR.$filename)) {
		my($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime(time());
		$year += 1900;
		$mon += 1;

		my($time) = sprintf("%02d:%02d",$hour,$min);
		print OFILE "$mday\t$time\t$type\n";
		close(OFILE);
	} else {
		$error = "Ͽ˼Ԥޤ";
		require "error.inc";
		exit;
	}
}

# μ

sub Get_Times
{
	my($filename,$result) = @_;

	my($record,$day,$time,$type);

	if(open(IFILE,$LOG_DIR.$filename)) {
		while($record = <IFILE>) {
			chomp($record);
			($day,$time,$type) = split("\t",$record);
			$day = int($day);
			$$result{$day}{$type} = $time;
		}
		close(IFILE);
		return 0;
	}
	return 1;
}

# ɤν

sub DownLoad_CSV
{
	my($year,$mon,$id) = @_;

	my($filename,$name,%list,$result,$day,$total,$time);

	my($mday) = &Get_Days($year,$mon);

	$filename = sprintf("%04d%02d_0.log",$year,$mon);
	$name = &Get_Member($filename,$id);

	$filename = sprintf("%04d%02d_%d.log",$year,$mon,$id);
	$result = &Get_Times($filename,\%list);

	$filename = sprintf("%04d%02d_%d.csv",$year,$mon,$id);

	print qq!Content-disposition: attachment; filename=$filename\n!;
	print qq!Content-Type: application/octet-stream; filename=$filename\n\n!;

	print &jcode'sjis(qq!$name($yearǯ$monʬ\r\n!,"euc");
	print &jcode'sjis(qq!ǯ,мһ,һ,̳\r\n!,"euc");

	for($day = 1;$day <= $mday;$day++) {
		$time = &Calc_Time($list{$day}{'I'},$list{$day}{'O'});
		$total += $time;
		print qq!$year/$mon/$day,$list{$day}{'I'},$list{$day}{'O'},!;
		print Form_Time($time),"\r\n";
	}
	print &jcode'sjis(qq!,,,!.Form_Time($total)."\r\n","euc");
}

1;

# Copyright (C) 2001-2003 All right reserved by Shinya Kondo ( CGI KON )
